###################################
# PROLOG SECTION
# new_password_advanced.py
# Validates a new password being proposed through user input.
# This is the advanced version of the program.
# In this version the user gets 3 tries to meet the conditions.
# Uses a for-loop.
#
# Tested with Python 3.7.9 on Windows 10
# Fri July 16, 2021
#
# Copyright ©. All rights reserved. NAF 2021.
#
# Possible future enhancements:
# Unresolved bugs:
###################################

###################################
# ENVIRONMENT SETUP SECTION
# Imports: no
###################################

###################################
# FUNCTION DEFINITION SECTION
# Definitions: no
###################################

###################################
# PROCESSING INITIALIZATION SECTION
###################################
# set minimum password length
minlength = 8
# set number of tries allowed
tries = 3
# initialize the password as invalid
valid = False
# print informational messages (password rules)
print()
print("Create a new password. You get three tries.")
print()
print("Rules for passwords:")
print("Must be at least",minlength,"characters in length")
print("Must contain only alphanumeric characters \
(no special characters like $ or #)")
print("Must contain at least one letter")
print("Must contain at least one digit")
print()

###################################
# PROCESSING SECTION
# Branching code: if/else
# Looping code: for-loop, break statement
###################################
#
# loop through the test code until the number of tries has been reached
# (note that the user input and test sections must be inside the loop)
# (note that everything under the loop must be indented)
#
# (note that this loop increments automatically)
# (it keeps track of how many times the test code is accessed)
# (therefore, an explicit i = i + 1 statement is NOT required)
for i in range(tries):
    #
    # get the user's input
    # 
    # prompt for the new password
    password = str(input("Enter new password: "))

    #
    # test the conditions and report errors
    #
    # test the password length
    if len(password) >= minlength:
        # test for all alphanumeric
        if password.isalnum():
            # make sure  there is at least one letter
            if not password.isdigit():
                # make sure there is at least one number
                if not password.isalpha():
                    # password passes all tests, mark it valid
                    valid = True
                    # if the password is valid after 1 or 2 tries
                    # break out of this section
                    # and proceed to the "cleanup" section
                    break
                else:
                    # there must be at least one digit in the password
                    print("Error, password does not contain a numeric digit.")
            else:
                # there must be at least one letter in the password
                print("Error, password does not contain a letter.")
        else:
            # password contains an invalid character
            print("Error, password is not alphanumeric.")
    else:
        # password was not long enough
        print("Error, password is less than",minlength,"characters.")
    
###################################   
# CLEANUP, TERMINATION, AND EXIT SECTION
###################################
#
# print informational messages (final status)
#
# if the password meets all conditions
if valid == True:
    # print the "successful" message
    print("Your new password is valid.")
# otherwise
else:
    # print the "unsuccessful" message
    print("Your new password is not valid.")
