###################################
# PROLOG SECTION
# new_password_intermediate.py
# Validates a new password being proposed through user input.
# This is the intermediate version of the program.
# Verifies that the password satisfies the following conditions:
# - Must be at least 8 characters in length
# - Must contain only alphanumeric characters
# - Must contain at least one letter
# - Must contain at least one number
# In this version the user gets only one try to meet the criteria
#
# Tested with Python 3.7.9 on Windows 10
# Fri July 16, 2021
#
# Copyright ©. All rights reserved. NAF 2021.
#
# Possible future enhancements:
# Unresolved bugs:
###################################

###################################
# PROCESSING INITIALIZATION SECTION
###################################
# set minimum password length
minlength = 8
# initialize the password as invalid
valid = False
# print the password rules
print()
print("Create a new password. You get only one try.")
print()
print("Rules for passwords:")
print("Must be at least",minlength,"characters in length")
print("Must contain only alphanumeric characters \
(no special characters like $ or #)")
print("Must contain at least one letter")
print("Must contain at least one digit")
print()

###################################
# PROCESSING SECTION
# Branching code: if/else
###################################
#
# get the user input
#
# prompt for the new password
password = str(input("Enter new password: "))
#
# test the conditions and report errors
#
# test the password length
if len(password) >= minlength:
    # test for all alphanumeric
    if password.isalnum():
        # test for at least one letter
        if not password.isdigit():
            # test for at least one digit
            if not password.isalpha():
                # password passes all tests, so mark it valid
                valid = True
            else:
                print("Error, password does not contain a numeric digit.")
        else:
            print("Error, password does not contain a letter.")
            
    else:
        print("Error, password is not alphanumeric.")
else:
    print("Error, password is less than",minlength,"characters.")
    
###################################   
# CLEANUP, TERMINATION, AND EXIT SECTION
###################################
# print informational messages (final status)
# if the password meets all conditions
if valid == True:
    # print the "successful" message
    print("Your new password is valid.")
# otherwise
else:
    # print the "unsuccessful" message
    print("Your new password is not valid.")
