###################################
# PROLOG SECTION
# number_guess_advanced.py
# A game to guess a number between 1 and 10.
# This is the advanced version of the program:
# - Builds on the basic and intermediate versions of the program.
# - Adds a while loop to give the user 3 tries to get the right answer.
# - The while statement goes ahead of the raw_input() statement.
# - The while loop requires the programmer to reindent various blocks.
# - The while loop requires the programmer to reword some of the messages.
#
# Tested with Python 3.7.9 on Windows 10
# Fri July 16, 2021
#
# Copyright ©. All rights reserved. NAF 2021.
#
# Possible future enhancements:
# Unresolved bugs:
###################################

###################################
# ENVIRONMENT SETUP SECTION
# Imports: Random number routines
###################################
# import random number routines
from random import *

###################################
# PROCESSING INITIALIZATION SECTION
###################################
# set the highest number to 10
number_max = 10
# pick the winning number,
# a random number between 1 and 10
the_number = randint(1,number_max)
# initialize the guess to an incorrect answer
guess = 0
# initialize the guess counter
guess_counter = 0
# print the rules for the game
print()
print("You have 3 tries to guess a number between 1 and " + str(number_max) + ".")
print("If you guess wrong, I'll tell you if your guess was too high or too low.")
print()

###################################
# PROCESSING SECTION
# Branching code: if/else
# Looping code: while-loop
###################################
#
# get the user's input and process it
#
# keep asking for a guess until the user guesses the number or runs out of tries
while guess != the_number and guess_counter != 3:
# this could also be stated "while not guess == the_number
# and not guess_counter == 3:"
    # get the input
    guess_string = str(input("Enter your numeric guess: "))
    # add to (increment) the guess counter
    guess_counter = guess_counter + 1
    
    # test to make sure we got numeric input
    if guess_string.isdigit():
        # convert the string entered to an integer
        guess = int(guess_string)
        # check to see if the guess is in the possible range of numbers
        if guess >= 1 and guess <= 10:
            # give a clue if the guess was not correct
            if guess < the_number:
                print("You guessed too low.")
            if guess > the_number:
                print("You guessed too high.")
        else:
            print("Sorry, you must guess between 1 and 10.")
    else:
        # error, the input was not a number
        print("Please enter a numeric guess.")

###################################   
# CLEANUP, TERMINATION, AND EXIT SECTION
###################################
#
# fall out of the loop when the guess is correct
# print informational messages (final status)
#
if guess == the_number:
    print("Congratulations, you guessed the number.")
else:
    print("Sorry, you ran out of tries.")
    print("The number was ",the_number,".")
