#
###################################
# PROLOG SECTION
# number_guess_basic.py
# A game to guess a number between 1 and 10.
# This is the basic version of the program:
# - Accepts user input.
# - Checks that input is numeric.
# - Converts numeric input to an integer.
# - Checks that the guess is in the range of valid numbers (1-10).
# - User has only one try.
# - Winning number is hard-coded into the program.
#
# Tested with Python 3.7.9 on Windows 10
# Fri July 16, 2021
#
# Copyright ©. All rights reserved. NAF 2021.
#
# Possible future enhancements:
# Unresolved bugs:
###################################

###################################
# PROCESSING INITIALIZATION SECTION
###################################
# pick the winning number
the_number = 5
# initialize the guess to an incorrect answer
guess = 0
# print the rules for the game
print()
print("You have 1 try to guess a number between 1 and 10.")
print("If you guess wrong, I'll tell you if your guess was too high or too low.")
print()

###################################
# PROCESSING SECTION
# Branching code: if/else
###################################
#
# get the user's guess and process it
#
guess_string = str(input("Enter your numeric guess: "))
# test to make sure we got numeric input
if guess_string.isdigit():
    # convert the string entered to an integer
    guess = int(guess_string)
    # check to see if the guess is in the possible range of numbers
    if guess >= 1 and guess <= 10:
        # give a clue if the guess was not correct
        if guess < the_number:
            print("You guessed too low.")
        if guess > the_number:
            print("You guessed too high.")
    else:
        print("Sorry, you must guess between 1 and 10.")
else:
    # error, the input was not a number
    print("Please enter a numeric guess.")

###################################   
# CLEANUP, TERMINATION, AND EXIT SECTION
###################################
#
# print winning and losing messages
#
# print winning message
if guess == the_number:
    print("Congratulations, you guessed the number.")
# print losing message
else:
    print("Try playing the game again.")
