# define_cards.py
# Defines and prints out the value of individual cards
# in a card deck as a number (0-51)
# plus a combination of rank and suit
# (e.g., 0 is "ace of clubs" and 51 is "king of spades")
#
# Tested with Python 3.7.9 on Windows 10
# Fri July 16, 2021
# Copyright ©. All rights reserved. NAF 2021.

# strings for card ranks
rank_string = ("ace","two","three","four","five","six","seven", \
               "eight","nine","ten","jack","queen","king")
# strings for card suits
suit_string = ("clubs","diamonds","hearts","spades")
# initialize the list of cards to null
cards = []
# build the strings for all cards in the deck
# begin with the suits
for suit in range(4):
    # first go through all ranks for clubs, then diamonds, etc.
    for rank in range(13):
        # assign the card string (e.g., "ace of clubs")
        # to the card_string variable
        card_string = rank_string[rank] + " of " + suit_string[suit]
        # append each card_string in turn
        # to the end of the list of cards
        cards.append(card_string)

# label the output
print("The cards are:")

# print the card numbers (i.e., 0-51)
# plus their values (e.g., "ace of clubs")
# for the entire deck of cards
for n in range(52):
    print(n+1,cards[n])
