###################################
# PROLOG SECTION
# olympic_rings_function.py
# Draws the Olympic rings using Turtle Graphics and uses a function.
# Tested with Python 3.7.9 on Windows 10
# Fri July 16, 2021
# Copyright ©. All rights reserved. NAF 2021.
#
# Possible future enhancements:
# Unresolved bugs:
###################################

###################################
# ENVIRONMENT SETUP SECTION
# Imports: turtle
###################################
# import turtle drawing routines
from turtle import *

###################################
# FUNCTION DEFINITION SECTION
# Defined Functions: draw_ring()
###################################
#
# This function draws a ring at a specified
# location, color, and radius.
#
# When the function is called, the values specified in the call
# are assigned to the variables in the function parameter list
# the variables only exist inside the function
# (this is called "local scope")
#
# definition statement, name of function, parameters (arguments)
def draw_ring(xcoord,ycoord,ring_color,ring_radius,turtle):
    # hide movement of the turtle
    turtle.up()
    # move to the ring location
    turtle.goto(xcoord,ycoord)
    # now show the turtle movement
    turtle.down()
    # set the color of the ring
    turtle.color(ring_color)
    # draw the ring
    turtle.circle(ring_radius)

###################################
# PROCESSING INITIALIZATION SECTION
###################################
# create the drawing window
setup(width=500,height=500,startx=0,starty=50)
# create a title for the drawing window
title("olympic_rings program using a function")
# create a turtle to draw with
turtle = Turtle()
# set the pen width
turtle.width(3)
# set the size of the rings
ring_radius = 75

###################################
# PROCESSING SECTION
# Draw the five rings by making calls to the draw_ring function.
# Branching code: none
# Looping code: none
###################################
# the user-defined function is called like a built-in function
draw_ring(-100,0,"blue",ring_radius,turtle)
draw_ring(0,0,"black",ring_radius,turtle)
draw_ring(100,0,"red",ring_radius,turtle)
draw_ring(-50,-75,"yellow",ring_radius,turtle)
draw_ring(50,-75,"green",ring_radius,turtle)

###################################   
# CLEANUP, TERMINATION, AND EXIT SECTION
###################################
# hide the turtle
turtle.hideturtle()
# end the program
done()
